[bitnami/mastodon] Release 4.1.2-debian-11-r6 (#31125)

Signed-off-by: Bitnami Containers <bitnami-bot@vmware.com>
This commit is contained in:
Bitnami Bot 2023-04-20 19:38:56 +02:00 committed by GitHub
parent b51abdb236
commit b0ba90ddfe
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
6 changed files with 110 additions and 22 deletions

View File

@ -2,11 +2,12 @@ FROM docker.io/bitnami/minideb:bullseye
ARG TARGETARCH
LABEL org.opencontainers.image.base.name="docker.io/bitnami/minideb:bullseye" \
org.opencontainers.image.created="2023-04-17T15:34:53Z" \
LABEL com.vmware.cp.artifact.flavor="sha256:109c7d51bd69bb6b3df71017440c1ea0699454f81fe188056c083f0b57c96ea6" \
org.opencontainers.image.base.name="docker.io/bitnami/minideb:bullseye" \
org.opencontainers.image.created="2023-04-20T16:58:10Z" \
org.opencontainers.image.description="Application packaged by VMware, Inc" \
org.opencontainers.image.licenses="Apache-2.0" \
org.opencontainers.image.ref.name="4.1.2-debian-11-r5" \
org.opencontainers.image.ref.name="4.1.2-debian-11-r6" \
org.opencontainers.image.title="mastodon" \
org.opencontainers.image.vendor="VMware, Inc." \
org.opencontainers.image.version="4.1.2"
@ -22,14 +23,13 @@ SHELL ["/bin/bash", "-o", "pipefail", "-c"]
RUN install_packages acl ca-certificates curl ffmpeg file imagemagick libbsd0 libbz2-1.0 libcom-err2 libcrypt1 libedit2 libffi7 libgcc-s1 libgmp10 libgnutls30 libgssapi-krb5-2 libhogweed6 libicu67 libidn11 libidn2-0 libk5crypto3 libkeyutils1 libkrb5-3 libkrb5support0 libldap-2.4-2 liblzma5 libmd0 libncursesw6 libnettle8 libnsl2 libp11-kit0 libpq5 libreadline-dev libreadline8 libsasl2-2 libsqlite3-0 libssl-dev libssl1.1 libstdc++6 libtasn1-6 libtinfo6 libtirpc3 libunistring2 libuuid1 libxml2 libxslt1.1 procps sqlite3 zlib1g
RUN mkdir -p /tmp/bitnami/pkg/cache/ && cd /tmp/bitnami/pkg/cache/ && \
COMPONENTS=( \
"python-3.8.16-9-linux-${OS_ARCH}-debian-11" \
"wait-for-port-1.0.6-4-linux-${OS_ARCH}-debian-11" \
"python-3.8.16-11-linux-${OS_ARCH}-debian-11" \
"wait-for-port-1.0.6-6-linux-${OS_ARCH}-debian-11" \
"ruby-3.0.6-0-linux-${OS_ARCH}-debian-11" \
"redis-client-7.0.10-0-linux-${OS_ARCH}-debian-11" \
"redis-client-7.0.11-0-linux-${OS_ARCH}-debian-11" \
"postgresql-client-15.2.0-4-linux-${OS_ARCH}-debian-11" \
"node-16.20.0-1-linux-${OS_ARCH}-debian-11" \
"mastodon-4.1.2-1-linux-${OS_ARCH}-debian-11" \
"gosu-1.16.0-5-linux-${OS_ARCH}-debian-11" \
) && \
for COMPONENT in "${COMPONENTS[@]}"; do \
if [ ! -f "${COMPONENT}.tar.gz" ]; then \

View File

@ -1,10 +1,4 @@
{
"gosu": {
"arch": "amd64",
"distro": "debian-11",
"type": "NAMI",
"version": "1.16.0-5"
},
"mastodon": {
"arch": "amd64",
"distro": "debian-11",
@ -27,13 +21,13 @@
"arch": "amd64",
"distro": "debian-11",
"type": "NAMI",
"version": "3.8.16-9"
"version": "3.8.16-11"
},
"redis-client": {
"arch": "amd64",
"distro": "debian-11",
"type": "NAMI",
"version": "7.0.10-0"
"version": "7.0.11-0"
},
"ruby": {
"arch": "amd64",
@ -45,6 +39,6 @@
"arch": "amd64",
"distro": "debian-11",
"type": "NAMI",
"version": "1.0.6-4"
"version": "1.0.6-6"
}
}

View File

@ -553,3 +553,98 @@ get_root_disk_device_id() {
get_root_disk_size() {
fdisk -l "$(get_root_disk_device_id)" | grep 'Disk.*bytes' | sed -E 's/.*, ([0-9]+) bytes,.*/\1/' || true
}
########################
# Run command as a specific user and group (optional)
# Arguments:
# $1 - USER(:GROUP) to switch to
# $2..$n - command to execute
# Returns:
# Exit code of the specified command
#########################
run_as_user() {
run_chroot "$@"
}
########################
# Execute command as a specific user and group (optional),
# replacing the current process image
# Arguments:
# $1 - USER(:GROUP) to switch to
# $2..$n - command to execute
# Returns:
# Exit code of the specified command
#########################
exec_as_user() {
run_chroot --replace-process "$@"
}
########################
# Run a command using chroot
# Arguments:
# $1 - USER(:GROUP) to switch to
# $2..$n - command to execute
# Flags:
# -r | --replace-process - Replace the current process image (optional)
# Returns:
# Exit code of the specified command
#########################
run_chroot() {
local userspec
local user
local homedir
local replace=false
local -r cwd="$(pwd)"
# Parse and validate flags
while [[ "$#" -gt 0 ]]; do
case "$1" in
-r | --replace-process)
replace=true
;;
--)
shift
break
;;
-*)
stderr_print "unrecognized flag $1"
return 1
;;
*)
break
;;
esac
shift
done
# Parse and validate arguments
if [[ "$#" -lt 2 ]]; then
echo "expected at least 2 arguments"
return 1
else
userspec=$1
shift
# userspec can optionally include the group, so we parse the user
user=$(echo "$userspec" | cut -d':' -f1)
fi
if ! am_i_root; then
error "Could not switch to '${userspec}': Operation not permitted"
return 1
fi
# Get the HOME directory for the user to switch, as chroot does
# not properly update this env and some scripts rely on it
homedir=$(eval echo "~${user}")
if [[ ! -d $homedir ]]; then
homedir="${HOME:-/}"
fi
# Obtaining value for "$@" indirectly in order to properly support shell parameter expansion
if [[ "$replace" = true ]]; then
exec chroot --userspec="$userspec" / bash -c "cd ${cwd}; export HOME=${homedir}; exec \"\$@\"" -- "$@"
else
chroot --userspec="$userspec" / bash -c "cd ${cwd}; export HOME=${homedir}; exec \"\$@\"" -- "$@"
fi
}

View File

@ -111,7 +111,7 @@ mastodon_validate() {
check_empty_value "MASTODON_S3_HOSTNAME"
check_resolved_hostname "$MASTODON_S3_HOSTNAME"
check_valid_port "MASTODON_S3_PORT_NUMBER"
check_empty_value "MASTODON_S3_ALIAS_HOST"
check_empty_value "MASTODON_S3_ALIAS"
check_empty_value "MASTODON_S3_ENDPOINT"
check_empty_value "MASTODON_AWS_ACCESS_KEY_ID"
check_empty_value "MASTODON_AWS_SECRET_ACCESS_KEY"
@ -155,7 +155,7 @@ mastodon_bundle_execute_print_output() {
# Avoid creating unnecessary cache files at initialization time
local -a cmd=("bundle" "exec" "$@")
# Run as application user to avoid having to change permissions/ownership afterwards
am_i_root && cmd=("gosu" "$MASTODON_DAEMON_USER" "${cmd[@]}")
am_i_root && cmd=("run_as_user" "$MASTODON_DAEMON_USER" "${cmd[@]}")
(
cd "$MASTODON_BASE_DIR" || false
"${cmd[@]}"
@ -240,7 +240,7 @@ mastodon_ensure_admin_user_exists() {
local res=""
if am_i_root; then
# Adding true to avoid the logic to exit
res="$(gosu "$MASTODON_DAEMON_USER" "${cmd[@]}" "${args[@]}" || true)"
res="$(run_as_user "$MASTODON_DAEMON_USER" "${cmd[@]}" "${args[@]}" || true)"
else
# Adding true to avoid the logic to exit
res="$("${cmd[@]}" "${args[@]}" || true)"

View File

@ -95,7 +95,6 @@ mastodon_env_vars=(
AWS_SECRET_ACCESS_KEY
AWS_ACCESS_KEY_ID
S3_ENDPOINT
S3_REGION
)
for env_var in "${mastodon_env_vars[@]}"; do
file_env_var="${env_var}_FILE"
@ -248,7 +247,7 @@ MASTODON_AWS_ACCESS_KEY_ID="${MASTODON_AWS_ACCESS_KEY_ID:-"${AWS_ACCESS_KEY_ID:-
export MASTODON_AWS_ACCESS_KEY_ID="${MASTODON_AWS_ACCESS_KEY_ID:-}"
export AWS_ACCESS_KEY_ID="$MASTODON_AWS_ACCESS_KEY_ID"
export MASTODON_CFG_AWS_ACCESS_KEY_ID="$MASTODON_AWS_ACCESS_KEY_ID"
export MASTODON_S3_REGION="${MASTODON_S3_REGION:-"${S3_REGION:-us-east-1}"}"
export MASTODON_S3_REGION="${MASTODON_S3_REGION:-us-east-1}"
MASTODON_S3_ENDPOINT="${MASTODON_S3_ENDPOINT:-"${S3_ENDPOINT:-}"}"
export MASTODON_S3_ENDPOINT="${MASTODON_S3_ENDPOINT:-${MASTODON_S3_PROTOCOL}://${MASTODON_S3_HOSTNAME}:${MASTODON_S3_PORT_NUMBER}}"
export S3_ENDPOINT="$MASTODON_S3_ENDPOINT"

View File

@ -45,7 +45,7 @@ fi
info "** Starting Mastodon ${MASTODON_MODE} **"
if am_i_root; then
exec gosu "$MASTODON_DAEMON_USER" "$cmd" "${args[@]}"
exec_as_user "$MASTODON_DAEMON_USER" "$cmd" "${args[@]}"
else
exec "$cmd" "${args[@]}"
fi